import network
from esp import espnow
import time
from machine import Pin, I2C
from ssd1306 import SSD1306_I2C
i2c = I2C(scl=Pin(22),sda=Pin(21),freq=100000)

w0 = network.WLAN(network.STA_IF)  
w0.active(True)

def tx(result):
    mac, sent = result
    print("send: %s - %r" % (mac,sent))


e = espnow
e.init()
pBeam = b'\x3c\x61\x05\x03\xb5\xc0'   
e.add_peer(pBeam)
pBon = b'\xe8\x68\xe7\x19\xaa\xb0'   
e.add_peer(pBon)

espnow.on_send(tx)
espnow.pmk('0123456789abcdef')



while True:
    time.sleep(0.2)
    status = i2c.readfrom(0x50,5)
    if status == b'Confr':
        e.send(pBon, 'A')
        print("Receive data from STM32:", status)
    elif status == b'Enter':
        e.send(pBeam, 'E')
        print("Receive data from STM32:", status)
    elif status == b'Backs':
        e.send(pBeam, 'B')
        print("Receive data from STM32:", status)
    elif status == b'Capsl':
        e.send(pBeam, 'C')
        print("Receive data from STM32:", status)