import network
from esp import espnow

import time
from machine import Pin, I2C
from ssd1306 import SSD1306_I2C

i2c = I2C(scl=Pin(22),sda=Pin(21),freq=100000)
w0 = network.WLAN(network.STA_IF)  
w0.active(True)

e = espnow
e.init()
pBeam = b'\x3c\x61\x05\x03\xb5\xc0'   
e.add_peer(pBeam)
pNik = b'\xe8\xdb\x84\x00\xd9\xe8'  
e.add_peer(pNik)

status = '-'

def tx(result):
    mac, sent = result
    print("send: %s - %r" % (mac,sent))

def rx(result):
    mac, msg = result
    byt = chr(ord(msg))
    if byt == 'A':
        a = i2c.readfrom(0x50, 1)
        print("Receive data from STM32 ",chr(a[0]))
        e.send(pBeam, chr(a[0]))


espnow.on_send(tx)
espnow.pmk('0123456789abcdef')

i = 0
while True: 
    msg = e.on_recv(rx)
    time.sleep(0.2)

