#include "mbed.h"
#include "string.h"


#define BLINKING_RATE     500ms

I2CSlave slave(D4,D5);


AnalogIn   f0(A0);
AnalogIn   f1(A1);
AnalogIn   f2(A2);
AnalogIn   f3(A6);
AnalogIn   f4(A3);
int t0; 
int t1; 
int t2; 
int t3; 
int t4; 

int tx0 = 0;
int tx1 = 0;
int tx2 = 0;
int tx3 = 0;
int tx4 = 0;

int cou = 0;
int ch_x;
int ch_cou = 0;

int chk;

char alp[33] = {'-','A','E','N','I','D','T','_','O','K','M','F','L','G','-','R','U','Y','B','P',
'Z','W','Q','J','S','-','X','V','-','C','H','-'};

char word[] = "Z";

void alp_hash(int x){
    if(x > 0){
        printf("%d%d%d%d%d\n",tx4,tx3,tx2,tx1,tx0);
        printf("%c\n",alp[x]);
        word[0] = alp[x];
    }
}

int hash_status(){
    int num = 0;
    num = (num*2) + tx4; 
    num = (num*2) + tx3; 
    num = (num*2) + tx2; 
    num = (num*2) + tx1; 
    num = (num*2) + tx0;
    return num; 
}

int check_status(int x){
    if(x == ch_x){
        ch_cou++;
    }
    else{
        ch_x = x;
        ch_cou = 0;
    }

    if(ch_cou == 5){
        alp_hash(x);
        return 1;
    }
    return 0;
}

int update_status(){
    int ch = 0;

    if(t0 >= 330)
        tx0 = 1;
    else
        tx0 = 0;
    if(t1 >= 280)
        tx1 = 1;
    else
        tx1 = 0;
    if(t2 >= 350)
        tx2 = 1;
    else
        tx2 = 0;
    if(t3 >= 370)
        tx3 = 1;
    else
        tx3 = 0;
    if(t4 >= 500) //special
        tx4 = 1;
    else
        tx4 = 0;

    int hash = hash_status();
    if(hash > 0)
        cou++;
    else
        cou = 0;
        
    if(cou >= 10){
        int hash = hash_status();
        int ch = check_status(hash);
        cou = 0;
    }
    return ch;
}

int main()
{
    
    char buf[20];
    slave.address(0xA0); 

    while (true) { 
        t0 = int(f0.read_u16());
        t1 = int(f1.read_u16());
        t2 = int(f2.read_u16());
        t3 = int(f3.read_u16());
        t4 = int(f4.read_u16());
        

        chk = update_status();
        int i = slave.receive();
        switch (i) {
            case I2CSlave::ReadAddressed:
                slave.write(word, 3);
                break;
            case I2CSlave::WriteAddressed:
                slave.read(buf,sizeof(buf)-1);
                printf("Read: %s\n", buf);
                break;
        }
        
    }
}